// Configuration
	
// Target. At the moment the only supported target is "VIRTEX"
// for Xilinx Virtex, Virtex-e and Spartan2v FPGAs.
`define TARGET "VIRTEX"
	
// Multiplier unit type. Valid are "NONE", "BOOTH" and "LIB".
`define MUL_TYPE "LIB"

// Logical address width. Recommended value 28
// (for 256MB virtual address space).
`define LADDR_WIDTH 28

// Physical address width. Recommended value 28
// (for 256MB physical address space).
`define PADDR_WIDTH `LADDR_WIDTH

// Exceptions
`define EXCEPT_RESET		3'd1
`define EXCEPT_MACH_CHK		3'd2
`define EXCEPT_DMMU_PAGEFAULT	3'd3
`define EXCEPT_IMMU_PAGEFAULT	3'd4
`define EXCEPT_EXT_INTERRUPT	3'd5
`define EXCEPT_ILLEGAL_INSN	3'd7
`define EXCEPT_DMMU_MISS	3'd8
`define EXCEPT_IMMU_MISS	3'd9

// Width of integer data. Recommended value 32
`define DATA_WIDTH 32

// Size of instructions. Valid value is 32 for OR32 ISA.
`define INSN_WIDTH 32

// Size of instructions in 16 bits. Valid value is 2 for OR32 ISA.
`define INSN_WIDTH_16 2

// Number of Chip Select signals. Default value is 4.
`define CSS 4

// Number of Interrupt Request signals. Default value is 4.
`define IRQS 4

// Constants
// Selects for IS muxes
`define SEL1_REGFILE	2'b00
`define SEL1_FORW_WB	2'b01
`define SEL1_FORW_RET	2'b10
`define SEL2_REGFILE	2'b00
`define SEL2_IMM	2'b01
`define SEL2_FORW_WB	2'b10
`define SEL2_FORW_RET	2'b11

// AOP constants
`define AOP_ADD	0
`define AOP_SUB	1
`define AOP_X	0

// LOP constants
`define LOP_AND	2'b00
`define LOP_OR	2'b01
`define LOP_XOR	2'b10
`define LOP_NOR	2'b11
`define LOP_X	2'b00

// SHIFT and ROTATE constants
`define SH_LEFTLOGIC	2'b00
`define SH_RIGHTLOGIC	2'b01
`define SH_RIGHTARITH	2'b10
`define ROT_LEFT	2'b11
`define ROT_RIGHT	2'b11
`define SH_X		2'b11

// Selects for WB mux
`define SELWB_ARITH	2'b00
`define SELWB_LOGIC	2'b01
`define SELWB_SH_ROT	2'b10
`define SELWB_LSU	2'b11
`define SELWB_X		2'b00

// Selects for WB mux
`define LSU_SIZE_WORD	2'b00
`define LSU_SIZE_BYTE	2'b01
`define LSU_SIZE_HALF	2'b10
`define LSU_SIZE_X	2'b11

// Transaction type
`define TA_NONE		3'b000
`define TA_FETCH	3'b001
`define TA_LOAD		3'b010
`define TA_STORE	3'b011
`define TA_BR		3'b100

`include "or32isa.h"
