`include "config.h"

module cpu_tb();

  reg [31:0] mem[255:0];

  initial begin
    mem[0] = 32'h14000000;	// 00: l.nop
    mem[1] = 32'h14000000;	// 04: l.nop
    mem[2] = 32'h14000000;	// 08: l.nop
    mem[3] = 32'h14000000;	// 0c: l.nop
    mem[4] = 32'h9464000C;	// 10: l.addi	r3,r4,c
    mem[5] = 32'h94040000;	// 14: l.addi	r0,r4,0
    mem[6] = 32'h14000000;	// 18: l.nop
    mem[7] = 32'h14000000;	// 1c: l.nop
    mem[8] = 32'h94430006;	// 20: l.addi	r2,r3,6
    mem[9] = 32'h94A00007;	// 24: l.addi	r5,r0,7
    mem[10] = 32'h95230100;	// 28: l.addi	r9,r3,100h
    mem[11] = 32'hD40310b0;	// 2c: l.sw		b0(r3),r2	-- (7c) <= 12h
    mem[12] = 32'h95430101;	// 30: l.addi	rA,r3,101h
    mem[13] = 32'h95630102;	// 34: l.addi	rB,r3,102h
    mem[14] = 32'h95230200;	// 38: l.addi	r9,r3,200h
    mem[15] = 32'h14000000;	// 3c: l.nop
    mem[16] = 32'h95230201;	// 40: l.addi	r9,r3,201h
    mem[17] = 32'h8109007c;	// 44: l.lw		r8,r9,7c
    mem[18] = 32'h95430202;	// 48: l.addi	rA,r3,202h
    mem[19] = 32'h95630203;	// 4c: l.addi	rB,r3,203h
    mem[20] = 32'h94640005;	// 50: l.addi	r3,r4,5
    mem[21] = 32'h94430006;	// 54: l.addi	r2,r3,6
    mem[22] = 32'h94640005;	// 58: l.addi	r3,r4,5
    mem[23] = 32'h14000000;	// 5c: l.nop
    mem[24] = 32'h14000000;	// 60: l.nop
    mem[25] = 32'h14000000;	// 64: l.nop
    mem[26] = 32'h14000000;	// 68: l.nop
    mem[27] = 32'h14000000;	// 6c: l.nop
    mem[28] = 32'hE4042000;	// 70: l.sfeq	r4,r4
    mem[29] = 32'h14000000;	// 74: l.nop
    mem[30] = 32'h14000000;	// 78: l.nop
    mem[31] = 32'hE4242000;	// 7c: l.sfne	r4,r4
    mem[32] = 32'h14000000;	// 80: l.nop
    mem[33] = 32'h14000000;	// 84: l.nop
    mem[34] = 32'hE4642000;	// 88: l.sfgeu	r4,r4
    mem[35] = 32'h14000000;	// 8c: l.nop
    mem[36] = 32'h14000000;	// 90: l.nop
    mem[37] = 32'hE4842000;	// 94: l.sfltu	r4,r4
    mem[38] = 32'h14000000;	// 98: l.nop
    mem[39] = 32'h14000000;	// 9c: l.nop
    mem[40] = 32'hE4A41800;	// a0: l.sfleu	r4,r3
    mem[41] = 32'h14000000;	// a4: l.nop
    mem[42] = 32'h08000123;	// a8: l.bnf	123
    mem[43] = 32'h14000000;	// ac: l.nop
    mem[44] = 32'h0c000125;	// b0: l.bf		125
    mem[45] = 32'h14000000;	// b4: 
    mem[46] = 32'h77777777;	// b8: 
    mem[47] = 32'h77777777;	// bc: nop
  end

// Stimulus signals - signals mapped to the input and inout ports of tested entity
  reg [`DATA_WIDTH-1:0] datain;
  wire [`DATA_WIDTH-1:0] dataout;
  reg busyn;
  reg bgn;
  reg rstn;
  reg clk;
// Observed signals - signals mapped to the output ports of tested entity
  wire [`PADDR_WIDTH-1:0] addr;
  wire [1:0] be;
  wire rw;
  wire burstn;
  wire validn;
  wire [`IRQS-1:0] irqn;
  wire [`CSS-1:0] csn;
  wire brn;

// Unit Under Test port map
  cpu UUT(addr, datain, dataout, be, rw, burstn, validn, busyn,
    irqn, csn, brn, bgn, rstn, clk);

//
// Reset, ~bg and ~busy
//
  initial begin
    busyn = 1;
    bgn = 0;
    rstn = 0;
    #130;
    rstn = 1;
  end

//
// Clock generator
//
  always begin
    clk = 1;
    #13;
    clk = 0;
    #13;
  end

//
// Memory
//
  integer memaddr;

  always @(posedge clk or negedge rstn)
    if (!rstn)
      datain <= #1 mem[0];
    else begin
      memaddr = addr / 4;
      if (memaddr > 47)
        memaddr = 0;
      if (rw) begin
        datain <= #1 mem[memaddr];
        $display($time,,"fetch mem[%x]: %x",memaddr,mem[memaddr]);
      end else
        datain <= #1 mem[0];
      if (!rw) begin
        mem[memaddr] <= #1 dataout;
        $display($time,,"store mem[%x] <- %x",memaddr,dataout);
      end
    end

endmodule
